//----------------------------------------------------------------------
//
//
//
//
//----------------------------------------------------------------------

#include <windows.h>
#include <dos.h> 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <shellapi.h>

#include <process.h>
#include "ctl3d.h"
#include "resource.h"  


#define VSCAMD_NAME		"vscamd.386"
#define VSCAMD_INIT		0
#define VSCAMD_SCAN		1  

char PagerTypes[][16] = { "DOS", "BIOS", "BLCK", "IFS" };

char signature[] = "MARKBRYC";		// Must be 8 bytes in length
char *vscamdid = "softscam95";

char msgbuf[ 200 ];

HINSTANCE 	hInst;
DWORD		dwVxDEntry;
struct vxdstats {   
	DWORD	DiskWrites;
	DWORD	PagesInRAM;
	DWORD	PagesOnDisk;
} VxDStats;    

// memory size in pages
WORD	MemSize;

//----------------------------------------------------------------------
//
// Abort
//
// Exits everything.
//
//----------------------------------------------------------------------
void Abort( HWND hWnd, char * Msg )
{
        MessageBox( hWnd, Msg, "SoftSCAM 95",
               		MB_ICONEXCLAMATION|MB_OK );
        EndDialog( hWnd, 1 );
        PostQuitMessage( 1 );
}


//----------------------------------------------------------------------
//  
// centerDialog
// 
// Centers the dialog box on the screen.
//
//----------------------------------------------------------------------
VOID centerWindow( HWND hWnd )
{
	RECT            aRt;

	// center the dialog box
	GetWindowRect( hWnd, &aRt );
	OffsetRect( &aRt, -aRt.left, -aRt.top );
	MoveWindow( hWnd,
			((GetSystemMetrics( SM_CXSCREEN ) -
				aRt.right ) / 2 + 4) & ~7,
  			(GetSystemMetrics( SM_CYSCREEN ) -
				aRt.bottom) / 2,
			aRt.right, aRt.bottom, 0 );
} 

 
void RunExperiment( HWND hdlg, HWND hTestDlg )
{
	WORD 		StatAddr = (WORD) &VxDStats;
	HGLOBAL  	page_array_handle;
	HGLOBAL far *page_array;
	DWORD		nPages, allocated;
	DWORD		page;
 	int 		len = strlen( signature );
 	WORD 		our_sig = (WORD) signature;  
 	WORD		pagertype;
 	DWORD		startTime, endTime;

		
	// Tell VxD to start counting things
     _asm {
            mov     dx, VSCAMD_INIT
            mov		bx, our_sig
            mov     ax, StatAddr
            call    dwVxDEntry
            mov		MemSize, ax
    } 
                                  
    nPages = MemSize;
	startTime = GetTickCount();
    
	// allocate buffer
	page_array_handle = GlobalAlloc( GPTR, nPages * sizeof(page_array_handle) );
	page_array = (HGLOBAL far *) GlobalLock( page_array_handle );
			
	// loop over pages, locking/filling/unlocking 
	allocated = 0;
	for ( page = 0; page < nPages; ++page )  {
		int j, i;

		char far * page_data;
		if( !(page_array[page] = GlobalAlloc( GMEM_FIXED|GMEM_NODISCARD, 4096 ))) {
			page_array[page] = 0;
		} else {
			// increment count
			allocated++;
			 
			// lock the buffer and get its address
			page_data = GlobalLock( page_array[page] ); 
		
			// fill buffer with identying string
			i= 0;
			for ( j = 0; j < 4096; j ++ ) {
				page_data[j] = signature[i++];
				if( !signature[i] )
					i = 0;
			}
			GlobalUnlock( page_array[page] );   
		}
	} 
	
	endTime = GetTickCount();

	// ask for vxd to scan
    _asm {
        mov     dx, VSCAMD_SCAN
        call    dwVxDEntry
        mov		pagertype, ax
    }  
                                       
	// update results
	SetDlgItemText( hdlg, IDC_PAGERTYPE, PagerTypes[pagertype] );
 	wsprintf( msgbuf, "%d", VxDStats.PagesInRAM );
	SetDlgItemText( hdlg, IDC_PAGESINRAM, msgbuf );
	wsprintf( msgbuf, "%d", VxDStats.PagesOnDisk );
	SetDlgItemText( hdlg, IDC_PAGESONDISK, msgbuf );
	wsprintf( msgbuf, "%d", VxDStats.DiskWrites );
	SetDlgItemText( hdlg, IDC_PAGESWRITTEN, msgbuf );
	wsprintf( msgbuf, "%d", allocated );
	SetDlgItemText( hdlg, IDC_PAGESALLOCATED, msgbuf );
	wsprintf( msgbuf, "%d", VxDStats.PagesOnDisk + VxDStats.PagesInRAM );
	SetDlgItemText( hdlg, IDC_TOTALPAGES, msgbuf );
	wsprintf( msgbuf, "%d", (endTime-startTime)/1000);
	SetDlgItemText( hdlg, IDC_TOTALTIME, msgbuf );
	                              
	// clear pages so that we don't find them later                              
	for ( page = 0; page < nPages; ++page )  { 
		if( page_array[page] ) {
			char far * page_data = GlobalLock( page_array[page] );
			_fmemset( page_data, 0, 4096 );
			GlobalUnlock( page_array[page] );
			GlobalFree( page_array[page] );   
		}
	}
	GlobalUnlock(page_array_handle);						
 	GlobalFree(page_array_handle);
 	
	DestroyWindow( hTestDlg );   
}



BOOL FAR PASCAL _export GenericDlgProc (HWND hDlg, UINT message, UINT wParam,
                                                               LONG lParam) {
	switch (message) {
	case WM_INITDIALOG :
		centerWindow( hDlg );
		return TRUE ;
 
	case WM_COMMAND :
		switch (wParam) {
		case IDOK :
			EndDialog (hDlg, 0) ;
			return TRUE ;
		}
		break ; 
	case WM_CLOSE:
		EndDialog (hDlg, 0);
		return TRUE;
	}
	return FALSE ;
}


//----------------------------------------------------------------------
//  
// MainDialog
// 
// Message handling procedure.
//
//----------------------------------------------------------------------
BOOL CALLBACK MainDialog( HWND hDlg, UINT message, WPARAM wParam, 
			    LPARAM lParam )
{
    switch ( message ) {
    case WM_INITDIALOG:
    
        // open the handle to the VXD 
        _asm {
        		push	es 
        		push	di 
        		mov		di, 0
				push	0
				pop		es
                mov     ax, 0x168A
                mov     si, vscamdid
                int     0x2F
                mov     word ptr dwVxDEntry, di
                mov     word ptr dwVxDEntry+2, es 
                pop		di
                pop		es
        }

        if( !dwVxDEntry )  {
 	       	wsprintf( msgbuf, "Couldn't open vxd\nSee the Readme" );
	       	Abort( hDlg, msgbuf );
            return(0);
        }
        SetDlgItemText( hDlg, IDC_PAGERTYPE, "?" );
		SetDlgItemText( hDlg, IDC_DISKWRITES, "0" );
		SetDlgItemText( hDlg, IDC_PAGESALLOCATED, "0" );
		SetDlgItemText( hDlg, IDC_PAGESINRAM, "0" );
		SetDlgItemText( hDlg, IDC_PAGESONDISK, "0" ); 
		SetDlgItemText( hDlg, IDC_TOTALTIME, "0" );
		SetDlgItemText( hDlg, IDC_TOTALPAGES, "0" );
		centerWindow( hDlg );
		return FALSE;
		break;

    case WM_COMMAND:
    	switch( LOWORD( wParam ) ) {
    	
    	case IDSTART: {
            FARPROC lpTest;
            HWND  hTestDlg;
            lpTest = MakeProcInstance( (FARPROC)GenericDlgProc, hInst );
            hTestDlg = CreateDialog( hInst, "EXPERIMENT", hDlg, (DLGPROC)lpTest );
 			RunExperiment( hDlg, hTestDlg );                                       
			FreeProcInstance( lpTest );
  			return TRUE;
		}

		case IDCANCEL:
 			// unregister 3-d
			EndDialog (hDlg, 0);
			return TRUE;

		case IDABOUT:  {
             FARPROC lpProcAbout;
             lpProcAbout = MakeProcInstance( (FARPROC)GenericDlgProc, hInst );
             DialogBox( hInst, "ABOUT", hDlg, (DLGPROC)lpProcAbout );
             FreeProcInstance( lpProcAbout );
             return TRUE;
 		}

		case IDHELP:
 			if ( ShellExecute( hDlg, "open", "readme.txt", NULL, 
 								"/softscam", SW_SHOWNORMAL	) <= 32 )
 			{
 				MessageBox( hDlg, "Can't find help file", NULL, MB_OK );
 			}
			return TRUE;
		
		default:
			break;
		}
		break;
	
	case WM_CLOSE:
		EndDialog (hDlg, 0) ;
		return TRUE ;
	
    default:
    	break;
	}
	return FALSE; 
}
                                              
 
//----------------------------------------------------------------------
//  
// WinMain
// 
// Fires up a dialog box type window.
//
//----------------------------------------------------------------------
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
        				LPSTR lpCmdLine, int nCmdShow )
{
	MSG         msg;

   	hInst = hInstance;
   	
   	// register 3-d controls
   	Ctl3dRegister( hInst );
	Ctl3dAutoSubclass( hInst );

 	// create the dialog window
    DialogBox( hInstance, "DIALOG", NULL, MainDialog );  
    
    // unregister 3-d
	Ctl3dUnregister( hInst );

	return msg.wParam;   	
}
