/*
TH32.C -- revised 11/29/94
Very simple demo of some Toolhelp32 functions in Chicago

Causes fault in debug version of Build 490

from Andrew Schulman, Unauthorized Windows 95, p. 530-531

Revised 6/24/95:

Thuan Ewe explained that you have to do a separate snapshot on each
process in order to get the module name.

Uses UNOBFUSC.C (Thuan Ewe's code to locate KERNEL32 unobfuscator).

Sample output:

Process    PDB        Module     Parent     Context    #Threads
-------    --------   ------     ------     --------   --------
FFCF0611   816261F8   7EAD67E9   00000000   C0FD7334    4   KERNEL32.DLL
FFFFF7F5   8152901C   7EAD67E9   816261F8   C0FE1184    1   KERNEL32.DLL
FFFFC795   8152A07C   7EAD67EC   8152901C   C0FE2844    1   MPREXE.EXE
FFFF8131   8152E6D8   7EAD67E5   8152901C   C103CF6C    3   EXPLORER.EXE
FFFE6C8D   81530B64   7EAD67E6   8152E6D8   C103E67C    1   SYSTRAY.EXE
FFFE4371   81532498   7EAD67E9   8152E6D8   C103EEF0    1   KERNEL32.DLL
FFFE453D   815322D4   7EAD67F8   81532498   C1041A3C    1   TH32.EXE

(Module is obfuscated.  Need MIDToMDB.)

Module     Process    BaseAddr   BaseSize   hModule
--------   --------   --------   --------   --------
7EAD67F8   FFFE453D   00400000   0000B000   00400000
7EAD67E9   FFFE453D   BFF70000   00064000   BFF70000

(Need to get all modules, not just for this process.  Show name for each
module.)

Thread      Process    Flags
--------   --------   --------
FFCF04E1   FFCF0611   00000000
FFFF1C49   FFCF0611   00000000
FFFFEB69   FFCF0611   00000000
FFFFF459   FFFFF7F5   00000000
FFFFF0E1   FFCF0611   00000000
FFFFC365   FFFFC795   00000000
FFFF95A9   FFFF8131   00000000
FFFF8A59   FFFF8131   00000000
FFFE6881   FFFE6C8D   00000000
FFFF8DF9   FFFF8131   00000000
FFFE4935   FFFE4371   00000000
FFFE4FB1   FFFE453D   00000000

(Not showing Flags any more.  Now showing Ring 0 THCB.  See below.)

Changed to display Win16 TDB for each process:

PDB        Module     Parent     Context      #Thrd     TDB
--------   ------     ------     --------     -----     ----
816241F8   7EAD70A9   00000000   C103A8F8       4       0097    KERNEL32.DLL
81527014   7EAD70A9   816241F8   C0FE0EC0       1       1516    KERNEL32.DLL
81527A9C   7EAD70A9   81527014   C0FE1844       1       1316    KERNEL32.DLL
81528784   7EAD70AC   81527014   C0FE200C       1       1F16    MPREXE.EXE
8152CDC0   7EAD70A5   81527014   C103C634       3       1DF6    EXPLORER.EXE
81530AF8   7EAD70BB   8152CDC0   C103DCE4       1       1AA6    SYSTRAY.EXE
81530090   7EAD70A9   8152CDC0   C103D300       1       1A66    KERNEL32.DLL
8153219C   7EAD70A9   8152CDC0   C103D7C4       1       40CE    KERNEL32.DLL
81535354   7EAD70BD   81530090   C104630C       1       19E6    TH32.EXE

Module info looks wrong.  Compare with output of WinICE MOD command:
:mod
hMod PEHeader      Module Name       .EXE File Name
010F               KERNEL            C:\WINDOWS\SYSTEM\KRNL386.EXE
01CF               SYSTEM            C:\WINDOWS\SYSTEM\system.drv
01C7               KEYBOARD          C:\WINDOWS\SYSTEM\keyboard.drv
...
1BE7               WINOLDAP          C:\WINDOWS\SYSTEM\WINOA386.MOD
283F               PIFMGR            C:\WINDOWS\SYSTEM\PIFMGR.DLL
2807               DOSAPP            C:\WINDOWS\fonts\dosapp.fon
019F 013F:BFF70080 KERNEL32          C:\WINDOWS\SYSTEM\KERNEL32.DLL
01A7 013F:815181C0 GDI32             C:\WINDOWS\SYSTEM\GDI32.DLL
06B7 013F:8151851C ADVAPI32          C:\WINDOWS\SYSTEM\ADVAPI32.DLL
06BF 013F:81518880 USER32            C:\WINDOWS\SYSTEM\USER32.DLL
1FDF 013F:8151A1AC MPR               C:\WINDOWS\SYSTEM\MPR.DLL
...
1DAF 013F:81521604 FINDSTUB          C:\PROGRAM FILES\THE MICROSOFT NETWORK\FIND
1D9F 013F:81521ABC LINKINFO          C:\WINDOWS\SYSTEM\LINKINFO.DLL
1A6F 013F:8152323C SYSTRAY           C:\WINDOWS\SYSTEM\SYSTRAY.EXE
1CFF 013F:81524AA4 MSADP32           C:\WINDOWS\SYSTEM\MSADP32.ACM

(Note above that modules can have long filenames.)

Currently only printing modules visible within TH32!
See inner Module32First/Next walk, with nested CreateToolhelp32Snapshot,
inside Process32First/Next walk (to find name).  Use this for module
walk:  for each process, walk all modules, save results in list.

Module unobfuscation:
WINICE shows TH32 @ 013F:81524F24
TH32   shows TH32 @      7EAE705D
81524F24 ^ 7EAE705D == FFFC3F79
Search for this pattern in memory; WinICE found at C16C125B
However, BPM on this location not triggered!

Changed display to show link from Ring 3 -> Ring 0 THCB:

Thread     Process    Ring 0
--------   --------   --------
8161A304   C159F060   8161A1F4
8151BB8C   C0FD6348   8161A1F4
8151CC74   C10CD3B4   8161A1F4
8151D3A4   C0FE0778   8151D010
8151D6FC   C0FE0934   8161A1F4
8151DE2C   C0FE1058   8151DA98
8151EB90   C1038208   8151E780
81523944   C103A0B8   81522DDC
81525258   C103AD3C   81522DDC
81526630   C103B4E4   81526238
81526EA4   C103F5CC   81526AB8
81527934   C103A858   81526090
815287D4   C10447E0   815280F0

Looks like multiple Ring 3 THCB can -> single Ring 0 THCB?!?!

Also show Win16 structures.  Either call Win16 Toolhelp, as example of
thunking, and/or access TDB, etc. directly using VxDCall -> DPMI.  In
any case, need generic DPMI32.C library for Win32 (GetSelectorBase, etc.).
*/

#include <stdlib.h>
#include <stdio.h>
#define  WIN32_LEAN_AND_MEAN
#include "windows.h"

#include "unobfusc.h"

#if 0
#include "tlhelp32.h"
#else
#define TH32CS_SNAPHEAPLIST 0x00000001
#define TH32CS_SNAPPROCESS  0x00000002
#define TH32CS_SNAPTHREAD   0x00000004
#define TH32CS_SNAPMODULE   0x00000008
#define TH32CS_SNAPALL      (TH32CS_SNAPHEAPLIST | TH32CS_SNAPPROCESS | TH32CS_SNAPTHREAD | TH32CS_SNAPMODULE)

typedef struct tagPROCESSENTRY32
{
    DWORD   dwSize;
    DWORD   cntUsage;
    DWORD   th32ProcessID;      // this process
    DWORD   th32DefaultHeapID;
    DWORD   th32ModuleID;       // associated exe
    DWORD   cntThreads;
    DWORD   th32ParentProcessID;    // this process's parent process
    LONG    pcPriClassBase;     // Base priority of process's threads
    DWORD   dwFlags;
} PROCESSENTRY32;
typedef PROCESSENTRY32 *  PPROCESSENTRY32;
typedef PROCESSENTRY32 *  LPPROCESSENTRY32;

#define MAX_MODULE_NAME32 255

typedef struct tagMODULEENTRY32
{
    DWORD   dwSize;
    DWORD   th32ModuleID;   // This module
    DWORD   th32ProcessID;  // owning process
    DWORD   GlblcntUsage;   // Global usage count on the module
    DWORD   ProccntUsage;   // Module usage count in th32ProcessID's context
    BYTE  * modBaseAddr;    // Base address of module in th32ProcessID's context
    DWORD   modBaseSize;    // Size in bytes of module starting at modBaseAddr
    HMODULE hModule;        // The hModule of this module in th32ProcessID's context
    char    szModule[MAX_MODULE_NAME32 + 1];
    char    szExePath[MAX_PATH];
} MODULEENTRY32;
typedef MODULEENTRY32 *  PMODULEENTRY32;
typedef MODULEENTRY32 *  LPMODULEENTRY32;

typedef struct tagTHREADENTRY32
{
    DWORD   dwSize;
    DWORD   cntUsage;
    DWORD   th32ThreadID;   // this thread
    DWORD   th32OwnerProcessID; // Process this thread is associated with
    LONG    tpBasePri;
    LONG    tpDeltaPri;
    DWORD   dwFlags;
} THREADENTRY32;
typedef THREADENTRY32 *  PTHREADENTRY32;
typedef THREADENTRY32 *  LPTHREADENTRY32;
#endif

void fail(const char *s) { puts(s); exit(1); }

main()
{
    struct PDB_t *pdb;
    PROCESSENTRY32 pe32;
    MODULEENTRY32 me32;
    THREADENTRY32 te32;
    BOOL ok, ok2;
    HANDLE snap, snap2;
    char *name;

    HANDLE (WINAPI *CreateToolhelp32Snapshot)(DWORD dwFlags, 
        DWORD th32ProcessID);
    BOOL (WINAPI *Process32First)(HANDLE hSnapshot, LPPROCESSENTRY32 lppe);
    BOOL (WINAPI *Process32Next)(HANDLE hSnapshot, LPPROCESSENTRY32 lppe);
    BOOL (WINAPI *Module32First)(HANDLE hSnapshot, LPMODULEENTRY32 lpme);
    BOOL (WINAPI *Module32Next)(HANDLE hSnapshot, LPMODULEENTRY32 lpme);
    BOOL (WINAPI *Thread32First)(HANDLE hSnapshot, LPTHREADENTRY32 lpte);
    BOOL (WINAPI *Thread32Next)(HANDLE hSnapshot, LPTHREADENTRY32 lpte);

    HANDLE k32 = GetModuleHandle("KERNEL32");
    #define GET(func) if (! (func = GetProcAddress(k32, #func))) \
        fail("Can't link to KERNEL32!" #func);
    
    // didn't seem to be in import library
    GET(CreateToolhelp32Snapshot);
    GET(Process32First);
    GET(Process32Next);
    GET(Module32First);
    GET(Module32Next);
    GET(Thread32First);
    GET(Thread32Next);

    /* Walk processes */
    
    if (! (snap = CreateToolhelp32Snapshot(TH32CS_SNAPALL, 0)))
        fail("Can't create Toolhelp32 snapshot");

printf("\nPDB        Module     Parent     Context      #Thrd     TDB\n");
  printf("--------   ------     ------     --------     -----     ----\n");
    
    pe32.dwSize = sizeof(pe32);
    for (ok=Process32First(snap, &pe32); ok; ok=Process32Next(snap, &pe32))
    {
        snap2 = CreateToolhelp32Snapshot(TH32CS_SNAPALL, pe32.th32ProcessID);
        if (snap2 == 0)
            continue;
        name = "";
        me32.dwSize = sizeof(me32);
        for (ok2=Module32First(snap2, &me32); ok2; 
             ok2=Module32Next(snap2, &me32))
            if (me32.th32ModuleID == pe32.th32ModuleID)
            {
                if (! (name = me32.szModule))
                    name = me32.szExePath;
                break;
            }
            
        CloseHandle(snap2);
        
        if ((pdb = PIDToPDBStruct(pe32.th32ProcessID)) != 0)
        {
            if (pdb->nThreads != pe32.cntThreads)
                fail("PIDToPDB mismatch: thread count!");

            if (PIDToPDBStruct(pe32.th32ParentProcessID) != pdb->ParentPDB)
                fail("PIDToPDB mismatch: parent process!");
        }
        
        printf("%08lX   %08lX   %08lX   %08lX   \t%d\t%04X\t%s\n",
            pdb, 
            pe32.th32ModuleID,
            PIDToPDB(pe32.th32ParentProcessID),
            pdb->MemContext,
            pe32.cntThreads,
            pdb->K16TDBSel,
            name);
    }
    
    /* Walk modules */

    printf("\nModule     Process    BaseAddr   BaseSize   hModule\n");
    printf("--------   --------   --------   --------   --------\n");
        
    name = "";
    me32.dwSize = sizeof(me32);
    for (ok=Module32First(snap, &me32); ok; ok=Module32Next(snap, &me32))
    {
        if (! (name = me32.szModule))
            name = me32.szExePath;
        printf("%08lX   %08lX   %08lX   %08lX   %08lX   %s\n",
            me32.th32ModuleID,
            me32.th32ProcessID,
            me32.modBaseAddr,
            me32.modBaseSize,
            me32.hModule,
            name);
    }
    
    /* Walk threads */
    
    printf("\n");
    printf("Thread     Process    Ring 0     TDB\n");
    printf("--------   --------   --------   ----\n");
    
    te32.dwSize = sizeof(te32);
    for (ok=Thread32First(snap, &te32); ok; ok=Thread32Next(snap, &te32))
    {
        DWORD tdb = TIDToTDB(te32.th32ThreadID);
        DWORD r0tdb = *((DWORD *) (tdb + 0x5C)); // Ring 0 thread
		WORD tdb16 = *((WORD *) (tdb + 0x1C));	 // Win16 TDB -- see CHGDIR.C
        if (*((DWORD *) (r0tdb + 0x0c)) != 0x42434854)      // 'THcb'
            fail("Ring 3 -> Ring 0 THCB link wrong!");
        printf("%08lX   %08lX   %08lX   %04X\n",
            tdb,
            r0tdb,
            PIDToPDB(te32.th32OwnerProcessID),
			tdb16);
    }
    
    CloseHandle(snap);
}
